Index: trunk/zoo-kernel/zoo_loader.c
===================================================================
--- trunk/zoo-kernel/zoo_loader.c	(revision 8)
+++ trunk/zoo-kernel/zoo_loader.c	(revision 9)
@@ -23,4 +23,7 @@
  */
 
+#define MALLOC_CHECK_ 0
+#define MALLOC_CHECK 0
+
 /**
  * Specific includes
@@ -31,10 +34,8 @@
 #include <sys/types.h>
 #include <unistd.h>
+#include "service_internal.h"
+
 extern "C" {
 #include "cgic.h"
-}
-
-#include "service_internal.h"
-extern "C" {
 #include <libxml/tree.h>
 #include <libxml/xmlmemory.h>
@@ -44,7 +45,26 @@
 }
 
+xmlXPathObjectPtr extractFromDoc(xmlDocPtr,char*);
+int runRequest(map*);
+
+using namespace std;
+
+/* ************************************************************************* */
+
+int errorException(maps *m, const char *message, const char *errorcode) 
+{
+  map * errormap = createMap("text", message);
+  addToMap(errormap,"code", errorcode);
+  printExceptionReportResponse(m,errormap);
+  freeMap(&errormap);
+  free(errormap);
+  return -1;
+}
+
+/* ************************************************************************* */
+
 #ifndef STRTOK_R
 char *
-strtok_r(char *s1, const char *s2, char **lasts)
+strtok_r (char *s1, const char *s2, char **lasts)
 {
   char *ret;
@@ -52,12 +72,12 @@
   if (s1 == NULL)
     s1 = *lasts;
-  while(*s1 && strchr(s2, *s1))
+  while (*s1 && strchr(s2, *s1))
     ++s1;
-  if(*s1 == '\0')
+  if (*s1 == '\0')
     return NULL;
   ret = s1;
-  while(*s1 && !strchr(s2, *s1))
+  while (*s1 && !strchr(s2, *s1))
     ++s1;
-  if(*s1)
+  if (*s1)
     *s1++ = '\0';
   *lasts = s1;
@@ -67,69 +87,6 @@
 #endif
 
-xmlNodeSet* extractFromDoc(xmlDocPtr,char*);
-int runRequest(map*);
-
-using namespace std;
-
-char* strtoupper(char* str)
-{
-  int leng=strlen(str);
-  for(int i=0; i<leng; i++)
-    if (97<=str[i]&&str[i]<=122)//a-z
-      str[i]-=32;
-  return str;
-}
-
-char* strtolower(char* str)
-{
-  int leng=strlen(str);
-  for(int i=0; i<leng; i++)
-    if (65<=str[i]&&str[i]<=90)//A-Z
-      str[i]+=32;
-  return str;
-}
-
-char* remplace(char* delim,char* rep,char* source){
-  if(strcmp(source,"")==0){
-#ifdef DEBUG
-    //char *tmp="RETURN NULL !\n";
-    //printf((void*)tmp);
-#endif
-    return "NULL";
-  }
-
-  char *_token; 
-  char *origin=strdup(source);
-  char result[1024]="";
-  _token = strtok(source, delim);
-#ifdef DEBUG
-  fprintf(stderr,"\nREPLACE TOKEN (%s == %s => %d)\n ",_token,origin,strcmp(_token,origin));
-#endif
-  if(strcmp(_token,origin)!=0)
-    while(_token!=NULL){
-      sprintf(result,"%s%s%s",result,_token,rep);
-      _token = strtok (NULL, delim);
-      if(_token==NULL)
-	result[strlen(result)-strlen(rep)]=0;
-#ifdef DEBUG
-      fprintf(stderr,"\n\nRESULT(%s)\n\n",result);
-#endif
-    }
-  else
-    return origin;
-  
-  return strdup(result);
-}
-
-
-char *colors[] = {
-  "red", "green", "blue"
-};
-
-#define colorsTotal 3
-#define TRUE -1
+#define TRUE 1
 #define FALSE -1
-static bool started=FALSE;
-static bool isStarted=FALSE;
 
 int cgiMain(){
@@ -140,12 +97,11 @@
   dup2(fileno(cgiOut),fileno(stdout));
 #ifdef DEBUG
-    fprintf(cgiOut,"Content-Type: text/plain; charset=utf-8\r\nStatus: 200 OK\r\n\r\n");
-    fprintf(cgiOut,"Welcome on ZOO verbose debuging mode \r\n\r\n");
-    fflush(cgiOut);
+  fprintf(cgiOut,"Content-Type: text/plain; charset=utf-8\r\nStatus: 200 OK\r\n\r\n");
+  fprintf(cgiOut,"Welcome on ZOO verbose debuging mode \r\n\r\n");
+  fflush(cgiOut);
 #endif
   
   /**
    * Read the main configuration file
-   */
   if(!isStarted){
     maps* m;
@@ -159,22 +115,25 @@
     isStarted=TRUE;
   }
-
-#ifdef DEBUG
-  char textb[23];
-  sprintf(textb,"\n%s\n%s\n",cgiRemoteAddr,cgiRequestMethod);
-  fprintf(stderr,"****%s\n%s\n***",textb,cgiQueryString);
-#endif
-
-  map* tmp=NULL;
+   */
+
+#ifdef DEBUG
+  fprintf (stderr, "Addr:%s\n", cgiRemoteAddr); 
+  fprintf (stderr, "RequestMethod:%s\n", cgiRequestMethod); 
+  fprintf (stderr, "Request: %s\n", cgiQueryString);
+#endif
+
+  map* tmpMap=NULL;
     
   if(strncmp(cgiContentType,"text/xml",8)==0){
-    char *buffer=new char[cgiContentLength];
+    char *buffer=new char[cgiContentLength+1];
     if(fread(buffer,1,cgiContentLength,cgiIn)){
       buffer[cgiContentLength]=0;
-      tmp=createMap("request",buffer);
+      tmpMap=createMap("request",buffer);
     }else{
       /* Here we have to return an error message ... */
+      fprintf(stderr, "Unable to read cgi content in zoo_loader.c line %i\n", __LINE__);      
       return 1; 
     }
+    delete[]buffer;
   }
   else{
@@ -190,9 +149,10 @@
       fprintf(stderr,"(( \n %s \n %s \n ))",*arrayStep,value);
 #endif
-      if(tmp!=NULL)
-	addToMap(tmp,*arrayStep,value);
+      if(tmpMap!=NULL)
+	addToMap(tmpMap,*arrayStep,value);
       else
-	tmp=createMap(*arrayStep,value);
+	tmpMap=createMap(*arrayStep,value);
       arrayStep++;
+      delete[]value;
     }
     cgiStringArrayFree(array);
@@ -201,46 +161,23 @@
   /**
    * In case that the POST method was used, then check if params came in XML
-   * format (attribute request should be the once).
-   */
-  if(strcmp(cgiRequestMethod,mtoupper("post"))==0 && count(tmp)==1){
+   * format else try to use the attribute "request" which should be the only 
+   * one.
+   */
+  if(strncasecmp(cgiRequestMethod,"post",4)==0 || count(tmpMap)==1){
     /**
      * First include the MetaPath and the ServiceProvider default parameters
      * (which should be always available in GET params so in cgiQueryString)
      */
-    char *saveptr1, *saveptr2;
-    char *str1, *str2, *token, *subtoken;
+    //char *saveptr1, *saveptr2;
+    char *str1/*, str2, *token, *subtoken*/;
     str1=cgiQueryString;
-    token=strtok_r(str1,"&",&saveptr1);
-    while(token!=NULL){
-#ifdef DEBUG
-      fprintf(stderr,"%s",token);
-#endif
-      str2=token;
-      subtoken=strtok_r(str2,"=",&saveptr2);
-#ifdef DEBUG
-      fprintf(stderr,"%s\n",subtoken);
-#endif
-      char* tmp_name;
-      if(subtoken!=NULL){
-	tmp_name=subtoken;
-#ifdef DEBUG
-	fprintf(stderr,"%s",subtoken);
-#endif
-	subtoken=strtok_r(NULL,"=",&saveptr2);
-	if(subtoken!=NULL)
-	  addToMap(tmp,tmp_name,subtoken);
-	else
-	  addToMap(tmp,tmp_name,"");
-      }
-      token=strtok_r(NULL,"&",&saveptr1);
-    }
     /**
      * Store the original XML request in xrequest map
      */
-    map* t1=getMap(tmp,"request");
+    map* t1=getMap(tmpMap,"request");
     if(t1!=NULL){
-      addToMap(tmp,"xrequest",t1->value);
+      addToMap(tmpMap,"xrequest",t1->value);
       xmlInitParser();
-      xmlDocPtr doc = xmlParseMemory(t1->value,cgiContentLength);      
+      xmlDocPtr doc = xmlParseMemory(t1->value,cgiContentLength);
       xmlNodePtr cur = xmlDocGetRootElement(doc);
       char *tval;
@@ -248,9 +185,9 @@
       tval = (char*) xmlGetProp(cur,BAD_CAST "service");
       if(tval!=NULL)
-	addToMap(tmp,"service",tval);
+	addToMap(tmpMap,"service",tval);
       tval=NULL;
       tval = (char*) xmlGetProp(cur,BAD_CAST "language");
       if(tval!=NULL)
-	addToMap(tmp,"language",tval);
+	addToMap(tmpMap,"language",tval);
       
       char* requests[3];
@@ -261,19 +198,25 @@
 	char tt[35];
 	sprintf(tt,"/*[local-name()='%s']",requests[j]);
-	xmlNodeSet* req=extractFromDoc(doc,tt);
-#ifdef DEBUG
-	fprintf(stderr,"%i",req->nodeNr);
-#endif
-	if(req->nodeNr==1){
-	  t1->value=requests[j];
-	  j=2;
+	xmlXPathObjectPtr reqptr=extractFromDoc(doc,tt);
+	if(reqptr!=NULL){
+	  xmlNodeSet* req=reqptr->nodesetval;
+#ifdef DEBUG
+	  fprintf(stderr,"%i",req->nodeNr);
+#endif
+	  if(req!=NULL && req->nodeNr==1){
+	    t1->value=requests[j];
+	    j=2;
+	  }
+	  xmlXPathFreeObject(reqptr);
 	}
-	xmlFree(req);
+	//xmlFree(req);
       }
-      if(strcmp(mtoupper(t1->value),mtoupper("GetCapabilities"))==0){	
-	xmlNodeSet* vers=extractFromDoc(doc,"/*/*/*[local-name()='Version']");
+      if(strncasecmp(t1->value,"GetCapabilities",15)==0){
+	xmlXPathObjectPtr versptr=extractFromDoc(doc,"/*/*/*[local-name()='Version']");
+	xmlNodeSet* vers=versptr->nodesetval;
 	xmlChar* content=xmlNodeListGetString(doc, vers->nodeTab[0]->xmlChildrenNode,1);
-	addToMap(tmp,"version",(char*)content);
-	xmlFree(vers);
+	addToMap(tmpMap,"version",(char*)content);
+	xmlXPathFreeObject(versptr);
+	//xmlFree(vers);
 	xmlFree(content);
       }else{
@@ -281,36 +224,50 @@
 	tval = (char*) xmlGetProp(cur,BAD_CAST "version");
 	if(tval!=NULL)
-	  addToMap(tmp,"version",tval);
+	  addToMap(tmpMap,"version",tval);
 	xmlFree(tval);
 	tval = (char*) xmlGetProp(cur,BAD_CAST "language");
 	if(tval!=NULL)
-	  addToMap(tmp,"language",tval);
-	xmlNodeSet* id=extractFromDoc(doc,"/*/*[local-name()='Identifier']");
-	char* identifiers=NULL;
-	identifiers=(char*)malloc(cgiContentLength);
-	identifiers[0]=0;
-	for(int k=0;k<id->nodeNr;k++){
-	  xmlChar* content=xmlNodeListGetString(doc, id->nodeTab[k]->xmlChildrenNode,1);
-	  if(strlen(identifiers)>0){
-	    sprintf(identifiers,"%s,%s",identifiers,content);
-	    identifiers[strlen(identifiers)]=0;
+	  addToMap(tmpMap,"language",tval);
+	xmlXPathObjectPtr idptr=extractFromDoc(doc,"/*/*[local-name()='Identifier']");
+	if(idptr!=NULL){
+	  xmlNodeSet* id=idptr->nodesetval;
+	  if(id!=NULL){
+	    char* identifiers=NULL;
+	    identifiers=(char*)calloc(cgiContentLength,sizeof(char));
+	    identifiers[0]=0;
+	    for(int k=0;k<id->nodeNr;k++){
+	      xmlChar* content=xmlNodeListGetString(doc, id->nodeTab[k]->xmlChildrenNode,1);
+	      if(strlen(identifiers)>0){
+		char *tmp=strdup(identifiers);
+		snprintf(identifiers,strlen(tmp)+xmlStrlen(content)+2,"%s,%s",tmp,content);
+		free(tmp);
+	      }
+	      else{
+		snprintf(identifiers,xmlStrlen(content)+1,"%s",content);
+	      }
+	      xmlFree(content);
+	    }
+	    xmlXPathFreeObject(idptr);
+	    addToMap(tmpMap,"Identifier",identifiers);
+	    free(identifiers);
 	  }
-	  else{
-	    sprintf(identifiers,"%s",content);
-	    identifiers[strlen(identifiers)]=0;
-	  }
-	  xmlFree(content);
 	}
-	xmlFree(id);
-	addToMap(tmp,"Identifier",identifiers);
+	//xmlFree(id);
       }
-      //xmlCleanupParser();
       xmlFree(tval);
-    }
-  }
-  //dumpMap(tmp);
-  runRequest(tmp);
-  //dumpMap(tmp);
-
+      xmlFreeDoc(doc);
+      xmlCleanupParser();
+    }
+  }
+
+  runRequest(tmpMap);
+
+  /** 
+   * Required but can't be made after executing a process using POST requests.
+   */
+  if(strncasecmp(cgiRequestMethod,"post",4)!=0 && count(tmpMap)!=1 && tmpMap!=NULL){
+    freeMap(&tmpMap);
+    free(tmpMap);
+  }
   return 0;
 
Index: trunk/zoo-kernel/zoo_service_loader.c
===================================================================
--- trunk/zoo-kernel/zoo_service_loader.c	(revision 8)
+++ trunk/zoo-kernel/zoo_service_loader.c	(revision 9)
@@ -27,4 +27,6 @@
 extern "C" int yylex();
 extern "C" int crlex();
+
+
 extern "C" {
 #include <libxml/tree.h>
@@ -71,19 +73,54 @@
 #include <stdarg.h>
 
-xmlNodeSet* extractFromDoc(xmlDocPtr doc,char* search){
+xmlXPathObjectPtr extractFromDoc(xmlDocPtr doc,char* search){
   xmlXPathContextPtr xpathCtx;
   xmlXPathObjectPtr xpathObj;
   xpathCtx = xmlXPathNewContext(doc);
   xpathObj = xmlXPathEvalExpression(BAD_CAST search,xpathCtx);
-  xmlXPathFreeContext(xpathCtx); 
-  return xpathObj->nodesetval;
+  xmlXPathFreeContext(xpathCtx);
+  return xpathObj;
 }
 
-void sigint_handler(int sig){
+void sig_handler(int sig){
+  char tmp[100];
+  char *ssig;
+  switch(sig){
+  case SIGSEGV:
+    ssig="SIGSEGV";
+    break;
+  case SIGTERM:
+    ssig="SIGTERM";
+    break;
+  case SIGINT:
+    ssig="SIGINT";
+    break;
+  case SIGILL:
+    ssig="SIGILL";
+    break;
+  case SIGFPE:
+    ssig="SIGFPE";
+    break;
+  case SIGABRT:
+    ssig="SIGABRT";
+    break;
+  default:
+    ssig="UNKNOWN";
+    break;
+  }
+  sprintf(tmp,"ZOO Kernel failed to process your request receiving signal %d = %s",sig,ssig);
+  errorException(NULL, tmp, "InternalError");
   fprintf(stderr,"Not this time!\n");
+  exit(0);
 }
 
 int runRequest(map* request_inputs)
 {
+
+  (void) signal(SIGSEGV,sig_handler);
+  (void) signal(SIGTERM,sig_handler);
+  (void) signal(SIGINT,sig_handler);
+  (void) signal(SIGILL,sig_handler);
+  (void) signal(SIGFPE,sig_handler);
+  (void) signal(SIGABRT,sig_handler);
 
   map* r_inputs=NULL,*tmps=NULL;
@@ -95,5 +132,8 @@
    * Parsing service specfic configuration file
    */
-  m=(maps*)malloc(MAPS_SIZE);
+  m=(maps*)calloc(1,MAPS_SIZE);
+  if(m == NULL){
+    return errorException(m, "Unable to allocate memory.", "InternalError");
+  }
   char ntmp[1024];
 #ifndef WIN32
@@ -102,63 +142,74 @@
   _getcwd(ntmp,1024);
 #endif
-  char conf_file[1024];
-  sprintf(conf_file,"%s/main.cfg",ntmp);  
+  r_inputs=getMap(request_inputs,"metapath");
+  if(r_inputs==NULL){
+    if(request_inputs==NULL)
+      request_inputs=createMap("metapath","");
+    else
+      addToMap(request_inputs,"metapath","");
+#ifdef DEBUG
+    fprintf(stderr,"ADD METAPATH\n");
+    dumpMap(request_inputs);
+#endif
+    r_inputs=getMap(request_inputs,"metapath");
+  }
+  char conf_file[10240];
+  snprintf(conf_file,10240,"%s/%s/main.cfg",ntmp,r_inputs->value);
   conf_read(conf_file,m);
-  
+#ifdef DEBUG
+  fprintf(stderr, "***** BEGIN MAPS\n"); 
+  dumpMaps(m);
+  fprintf(stderr, "***** END MAPS\n");
+#endif
+
   /**
    * Check for minimum inputs
    */
   r_inputs=getMap(request_inputs,"Request");
-  if(r_inputs==NULLMAP){ 
-  tmps=createMap("text","Parameter <request> was not specified");
-    addToMap(tmps,"code","MissingParameterValue");
-    printExceptionReportResponse(m,tmps);
+  if(request_inputs==NULL || r_inputs==NULL){ 
+    errorException(m, "Parameter <request> was not specified","MissingParameterValue");
+    freeMaps(&m);
+    free(m);
+    freeMap(&request_inputs);
+    free(request_inputs);
     return 1;
   }
-  else
+  else{
     REQUEST=strdup(r_inputs->value);
-  r_inputs=NULL;
-  r_inputs=getMap(request_inputs,"Service");
-  if(r_inputs==NULLMAP){ 
-    tmps=createMap("text","Parameter <service> was not specified");
-    addToMap(tmps,"code","MissingParameterValue");
-    printExceptionReportResponse(m,tmps);
-    return 1;
-  }
-  if(strcmp(mtoupper(REQUEST),"GETCAPABILITIES")!=0){
-    r_inputs=getMap(request_inputs,"Version");
-    if(r_inputs==NULL){ 
-      tmps=createMap("text","Parameter <version> was not specified");
-      addToMap(tmps,"code","MissingParameterValue");
-      printExceptionReportResponse(m,tmps);
+    if(strncasecmp(r_inputs->value,"GetCapabilities",15)!=0
+       && strncasecmp(r_inputs->value,"DescribeProcess",15)!=0
+       && strncasecmp(r_inputs->value,"Execute",7)!=0){ 
+      errorException(m, "Unenderstood <request> value. Please check that it was set to GetCapabilities, DescribeProcess or Execute.", "InvalidParameterValue");
+      freeMaps(&m);
+      free(m);
+      freeMap(&request_inputs);
+      free(request_inputs);
+      free(REQUEST);
       return 1;
     }
   }
-
-  /**
-   * Need to print std exception message here
-   */
-  char SP[1024];
-  if ((argc < 5 && strcmp(mtoupper(REQUEST),"GETCAPABILITIES")!=0) || (argc < 4 && strcmp(mtoupper(REQUEST),"GETCAPABILITIES")==0)){
-    r_inputs=getMap(request_inputs,"ServiceProvider");
-    if(r_inputs==NULLMAP){
-      tmps=createMap("text","Parameter <serviceprovider> was not specified");
-      addToMap(tmps,"code","MissingParameterValue");
-      printExceptionReportResponse(m,tmps);    
+  r_inputs=NULL;
+  r_inputs=getMap(request_inputs,"Service");
+  if(r_inputs==NULLMAP){
+    errorException(m, "Parameter <service> was not specified","MissingParameterValue");
+    freeMaps(&m);
+    free(m);
+    free(REQUEST);
+    return 1;
+  }
+  if(strncasecmp(REQUEST,"GetCapabilities",15)!=0){
+    r_inputs=getMap(request_inputs,"Version");
+    if(r_inputs==NULL){ 
+      errorException(m, "Parameter <version> was not specified","MissingParameterValue");
+      freeMaps(&m);
+      free(m);
+      free(REQUEST);
       return 1;
     }
-    else
-      sprintf(SP,"%s",r_inputs->value);
-    r_inputs=getMap(request_inputs,"MetaPath");
-    if(r_inputs==NULLMAP){
-      tmps=createMap("text","Parameter <metapath> was not specified");
-      addToMap(tmps,"code","MissingParameterValue");
-      printExceptionReportResponse(m,tmps);    
-      return 1;
-    }
-    tmps=createMap("text","Parameter <unknown> was not specified");
-    addToMap(tmps,"code","MissingParameterValue");
-    printExceptionReportResponse(m,tmps);    
-    return 1;
+  }
+
+  r_inputs=getMap(request_inputs,"serviceprovider");
+  if(r_inputs==NULL){
+    addToMap(request_inputs,"serviceprovider","");
   }
 
@@ -182,25 +233,30 @@
   char tmps1[1024];
 
-  if(strcmp(mtoupper(REQUEST),mtoupper("GetCapabilities"))==0){
+  r_inputs=NULL;
+  r_inputs=getMap(request_inputs,"metapath");
+  if(r_inputs!=NULL)
+    snprintf(conf_dir,1024,"%s/%s",ntmp,r_inputs->value);
+  else
+    snprintf(conf_dir,1024,"%s",ntmp);
+
+  if(strncasecmp(REQUEST,"GetCapabilities",15)==0){
     int i=0;
     struct dirent *dp;
-    r_inputs=NULL;
-    r_inputs=getMap(request_inputs,"metapath");
 #ifdef DEBUG
     dumpMap(r_inputs);
 #endif
-    sprintf(conf_dir,"%s/%s",ntmp,r_inputs->value);
-	DIR *dirp = opendir(conf_dir);
+    DIR *dirp = opendir(conf_dir);
     if(dirp==NULL){
-      tmps=createMap("text","The specified path doesn't exist.");
-      addToMap(tmps,"code","InvalidParameterValue");
-      printExceptionReportResponse(m,tmps);    
-      return -1;
+      return errorException(m, "The specified path doesn't exist.","InvalidParameterValue");
     }
     xmlDocPtr doc = xmlNewDoc(BAD_CAST "1.0");
-    doc->encoding = xmlCharStrdup ("UTF-8");
     r_inputs=NULL;
     r_inputs=getMap(request_inputs,"ServiceProvider");
-    xmlNodePtr n = printGetCapabilitiesHeader(doc,r_inputs->value,m);
+    xmlNodePtr n;
+    //dumpMap(request_inputs);
+    if(r_inputs!=NULL)
+      n = printGetCapabilitiesHeader(doc,r_inputs->value,m);
+    else
+      n = printGetCapabilitiesHeader(doc,"",m);
     /**
      * Strange, here we need to close stdout to ensure that no uneeded 
@@ -211,8 +267,10 @@
     while ((dp = readdir(dirp)) != NULL)
       if(strstr(dp->d_name,".zcfg")!=0){
-	sprintf(tmps1,"%s/%s",conf_dir,dp->d_name);
-	char *tmps=tmps1;
-	s1=(service*)malloc(sizeof(service*));
-	s[0]=(service*)malloc(sizeof(service*));
+	memset(tmps1,0,1024);
+	snprintf(tmps1,1024,"%s/%s",conf_dir,dp->d_name);
+	s1=(service*)calloc(1,SERVICE_SIZE);
+	if(s1 == NULL){ 
+	  return errorException(m, "Unable to allocate memory.","InternalError");
+	}
 #ifdef DEBUG
 	fprintf(stderr,"#################\n%s\n#################\n",tmps1);
@@ -224,8 +282,7 @@
 	fflush(stderr);
 #endif
-	s[0]=s1;
 	printGetCapabilitiesForProcess(m,n,s1);
-	//freeService(&s1);
-	//s1=NULL;
+	freeService(&s1);
+	free(s1);
 	scount++;
       }
@@ -233,8 +290,10 @@
     fflush(stdout);
     dup2(saved_stdout,fileno(stdout));
-    
-    printDocument(doc);
+    printDocument(m,doc,getpid());
+    freeMaps(&m);
+    free(m);
+    free(REQUEST);
+    free(SERVICE_URL);
     fflush(stdout);
-    xmlFree(n);
     return 0;
   }
@@ -243,34 +302,35 @@
     if(r_inputs==NULL 
        || strlen(r_inputs->name)==0 || strlen(r_inputs->value)==0){ 
-      if(r_inputs!=NULL && strlen(r_inputs->value)==0)
-	tmps=createMap("text","Mandatory value for <identifier> was not specified");
-      else
-	tmps=createMap("text","Mandatory <identifier> was not specified");
-      addToMap(tmps,"code","MissingParameterValue");
-      printExceptionReportResponse(m,tmps);
-      return 1;
+      errorException(m, "Mandatory <identifier> was not specified","MissingParameterValue");
+      freeMaps(&m);
+      free(m);
+      free(REQUEST);
+      free(SERVICE_URL);
+      return 0;
     }
 
-    r_inputs=getMap(request_inputs,"metapath");
-    sprintf(conf_dir,"%s/%s",ntmp,r_inputs->value);
     struct dirent *dp;
     DIR *dirp = opendir(conf_dir);
     if(dirp==NULL){
-      tmps=createMap("text","The specified metapath path doesn't exist.");
-      addToMap(tmps,"code","InvalidParameterValue");
-      printExceptionReportResponse(m,tmps);    
-      return -1;
+      errorException(m, "The specified path path doesn't exist.","InvalidParameterValue");
+      freeMaps(&m);
+      free(m);
+      free(REQUEST);
+      free(SERVICE_URL);
+      return 0;
     }
-    if(strcmp(mtoupper(REQUEST),"DESCRIBEPROCESS")==0){
+    if(strncasecmp(REQUEST,"DescribeProcess",15)==0){
       /**
        * Loop over Identifier list
        */
       xmlDocPtr doc = xmlNewDoc(BAD_CAST "1.0");
-      doc->encoding = xmlCharStrdup ("UTF-8");
       r_inputs=NULL;
       r_inputs=getMap(request_inputs,"ServiceProvider");
+
       xmlNodePtr n;
       if(r_inputs!=NULL)
 	n = printDescribeProcessHeader(doc,r_inputs->value,m);
+      else
+	n = printDescribeProcessHeader(doc,"",m);
 
       r_inputs=getMap(request_inputs,"Identifier");
@@ -286,5 +346,5 @@
       while(tmps){
 	memset(buff,0,256);
-	sprintf(buff,"%s.zcfg",tmps);
+	snprintf(buff,256,"%s.zcfg",tmps);
 	memset(buff1,0,1024);
 #ifdef DEBUG
@@ -294,16 +354,20 @@
 	  if(strcmp(dp->d_name,buff)==0){
 	    memset(buff1,0,1024);
-	    sprintf(buff1,"%s/%s",conf_dir,dp->d_name);
-	    s1=(service*)malloc(sizeof(service*));
-	    s[scount]=(service*)malloc(sizeof(service*));
-#ifdef DEBUG
-	    fprintf(stderr,"#################\n%s\n#################\n",tmps1);
+	    snprintf(buff1,1024,"%s/%s",conf_dir,dp->d_name);
+	    //s1=(service*)malloc(sizeof(service*));
+	    s1=(service*)calloc(1,SERVICE_SIZE);
+	    if(s1 == NULL){
+	      return errorException(m, "Unable to allocate memory.","InternalError");
+	    }
+#ifdef DEBUG
+	    fprintf(stderr,"#################\n%s\n#################\n",buff1);
 #endif
 	    t=getServiceFromFile(buff1,&s1);
-	    /*dumpService(s1);
-	      fflush(stdout);
-	      fflush(stderr);*/
-	    s[0]=s1;
-	    printDescribeProcessForProcess(m,n,s,1);
+#ifdef DEBUG
+	    dumpService(s1);
+#endif
+	    printDescribeProcessForProcess(m,n,s1,1);
+	    freeService(&s1);
+	    free(s1);
 	    scount++;
 	  }
@@ -311,38 +375,47 @@
 	tmps=strtok(NULL,",");
       }
-      (void)closedir(dirp);
+      closedir(dirp);
       fflush(stdout);
       dup2(saved_stdout,fileno(stdout));
-
-      printDocument(doc);
+      printDocument(m,doc,getpid());
+      freeMaps(&m);
+      free(m);
+      free(REQUEST);
+      free(SERVICE_URL);
       fflush(stdout);
       //xmlFree(n);
 #ifndef LINUX_FREE_ISSUE
-      free(s1);
+      if(s1)
+	free(s1);
 #endif
       return 0;
     }
     else
-      if(strcmp(mtoupper(REQUEST),"EXECUTE")!=0){
-	tmps=createMap("text","Unenderstood <request> value. Please check that it was set to GetCapabilities, DescribeProcess or Execute.");
-	addToMap(tmps,"code","InvalidParameterValue");
-	printExceptionReportResponse(m,tmps);
+      if(strncasecmp(REQUEST,"Execute",strlen(REQUEST))!=0){
+	errorException(m, "Unenderstood <request> value. Please check that it was set to GetCapabilities, DescribeProcess or Execute.", "InvalidParameterValue");
 #ifdef DEBUG
 	fprintf(stderr,"No request found %s",REQUEST);
 #endif	
+	closedir(dirp);
 	free(s);
 	return 0;
       }
+    closedir(dirp);
   }
   
   s1=NULL;
-  s1=(service*)malloc(sizeof(service*));
-  s[0]=(service*)malloc(sizeof(service*));
+  s1=(service*)calloc(1,SERVICE_SIZE);
+  if(s1 == NULL){
+    return errorException(m, "Unable to allocate memory.","InternalError");
+  }
   r_inputs=getMap(request_inputs,"MetaPath");
-  sprintf(tmps1,"%s/%s",ntmp,r_inputs->value);
+  if(r_inputs!=NULL)
+    snprintf(tmps1,1024,"%s/%s",ntmp,r_inputs->value);
+  else
+    snprintf(tmps1,1024,"%s/",ntmp);
   r_inputs=getMap(request_inputs,"Identifier");
-
-  sprintf(tmps1,"%s/%s.zcfg",strdup(tmps1),r_inputs->value);
-
+  char *ttmp=strdup(tmps1);
+  snprintf(tmps1,1024,"%s/%s.zcfg",ttmp,r_inputs->value);
+  free(ttmp);
 #ifdef DEBUG
   fprintf(stderr,"Trying to load %s\n", tmps1);
@@ -354,10 +427,8 @@
   dup2(saved_stdout,fileno(stdout));
   if(t==22){
-    tmps=createMap("text","The value for <indetifier> seems to be wrong. Please, ensure that the process exsits using the GetCapabilities request.");
-    addToMap(tmps,"code","InvalidParameterValue");
-    printExceptionReportResponse(m,tmps);
+    errorException(m, "The value for <indetifier> seems to be wrong. Please, ensure that the process exsits using the GetCapabilities request.", "InvalidParameterValue");
     exit(0);
   }
-  s[0]=s1;
+  //s[0]=s1;
 
 #ifdef DEBUG
@@ -399,16 +470,18 @@
 #endif
     r_inputs=getMap(request_inputs,"ResponseDocument");	
-    if(r_inputs==NULLMAP)
-      r_inputs=getMap(request_inputs,"RawDataOutput");
-#ifdef DEBUG
+    if(r_inputs==NULL) r_inputs=getMap(request_inputs,"RawDataOutput");
+    
+    //#ifdef DEBUG
     fprintf(stderr,"OUTPUT Parsing ... \n");
-#endif
-    if(r_inputs!=NULLMAP){
-#ifdef DEBUG
+    //#endif
+    if(r_inputs!=NULL){
+      //#ifdef DEBUG
       fprintf(stderr,"OUTPUT Parsing start now ... \n");
-#endif
+      //#endif
       char current_output_as_string[10240];
       char cursor_output[10240];
-      sprintf(cursor_output,"%s",strdup(r_inputs->value));
+      char *cotmp=strdup(r_inputs->value);
+      snprintf(cursor_output,10240,"%s",cotmp);
+      free(cotmp);
       j=0;
       map* request_kvp_outputs=NULL;
@@ -423,5 +496,8 @@
 #endif
       pToken=strtok(cursor_output,";");
-      char** outputs_as_text=(char**)malloc(128*sizeof(char*));
+      char** outputs_as_text=(char**)calloc(128,sizeof(char*));
+      if(outputs_as_text == NULL) {
+	return errorException(m, "Unable to allocate memory", "InternalError");
+      }
       i=0;
       while(pToken!=NULL){
@@ -431,6 +507,9 @@
 	fprintf(stderr,"***%s***\n",pToken);
 #endif
-	outputs_as_text[i]=(char*)malloc(strlen(pToken)*sizeof(char));
-	sprintf(outputs_as_text[i],"%s",pToken);
+	outputs_as_text[i]=(char*)calloc(strlen(pToken)+1,sizeof(char));
+	if(outputs_as_text[i] == NULL) {
+	  return errorException(m, "Unable to allocate memory", "InternalError");
+	}
+	snprintf(outputs_as_text[i],strlen(pToken)+1,"%s",pToken);
 	pToken = strtok(NULL,";");
 	i++;
@@ -438,4 +517,5 @@
       for(j=0;j<i;j++){
 	char *tmp=strdup(outputs_as_text[j]);
+	free(outputs_as_text[j]);
 	char *tmpc;
 	tmpc=strtok(tmp,"@");
@@ -444,5 +524,8 @@
 	  if(k==0){
 	    if(tmp_output==NULL){
-	      tmp_output=(maps*)malloc(MAPS_SIZE);
+	      tmp_output=(maps*)calloc(1,MAPS_SIZE);
+	      if(tmp_output == NULL){
+		return errorException(m, "Unable to allocate memory.", "InternalError");
+	      }
 	      tmp_output->name=strdup(tmpc);
 	      tmp_output->content=NULL;
@@ -473,13 +556,18 @@
 	}
 	if(request_output_real_format==NULL)
-	  request_output_real_format=tmp_output;
+	  request_output_real_format=dupMaps(&tmp_output);
 	else
 	  addMapsToMaps(&request_output_real_format,tmp_output);
+	freeMaps(&tmp_output);
+	free(tmp_output);
+	tmp_output=NULL;
 #ifdef DEBUG
 	dumpMaps(tmp_output);
 	fflush(stderr);
 #endif
-	tmp_output=tmp_output->next;
+	//tmp_output=tmp_output->next;
+	free(tmp);
       }
+      free(outputs_as_text);
     }
 
@@ -494,5 +582,14 @@
     char current_input_as_string[40960];
     char cursor_input[40960];
-    sprintf(cursor_input,"%s",strdup(r_inputs->value));
+    if(r_inputs!=NULL)
+      snprintf(cursor_input,40960,"%s",r_inputs->value);
+    else{
+      errorException(m, "Parameter <DataInputs> was not specified","MissingParameterValue");
+      freeMaps(&m);
+      free(m);
+      free(REQUEST);
+      free(SERVICE_URL);
+      return 0;
+    }
     j=0;
     map* request_kvp_inputs=NULL;
@@ -503,5 +600,8 @@
     char * pToken;
     pToken=strtok(cursor_input,";");
-    char** inputs_as_text=(char**)malloc(100*sizeof(char*));
+    char** inputs_as_text=(char**)calloc(100,sizeof(char*));
+    if(inputs_as_text == NULL){
+      return errorException(m, "Unable to allocate memory.", "InternalError");
+    }
     i=0;
     while(pToken!=NULL){
@@ -513,6 +613,9 @@
       fprintf(stderr,"***%s***\n",pToken);
 #endif
-      inputs_as_text[i]=(char*)malloc(strlen(pToken)*sizeof(char));
-      sprintf(inputs_as_text[i],"%s",pToken);
+      inputs_as_text[i]=(char*)calloc(strlen(pToken)+1,sizeof(char));
+      snprintf(inputs_as_text[i],strlen(pToken)+1,"%s",pToken);
+      if(inputs_as_text[i] == NULL){
+	return errorException(m, "Unable to allocate memory.", "InternalError");
+      }
       pToken = strtok(NULL,";");
       i++;
@@ -521,4 +624,5 @@
     for(j=0;j<i;j++){
       char *tmp=strdup(inputs_as_text[j]);
+      free(inputs_as_text[j]);
       char *tmpc;
       tmpc=strtok(tmp,"@");
@@ -537,5 +641,8 @@
 #endif
 	if(tmpmaps==NULL){
-	  tmpmaps=(maps*)malloc(MAPS_SIZE);
+	  tmpmaps=(maps*)calloc(1,MAPS_SIZE);
+	  if(tmpmaps == NULL){
+	    return errorException(m, "Unable to allocate memory.", "InternalError");
+	  }
 	  tmpmaps->name=strdup(tmpn);
 	  tmpmaps->content=createMap("value",tmpv+1);
@@ -566,37 +673,52 @@
 #endif
 #ifndef WIN32
-		if(CHECK_INET_HANDLE(hInternet))
-#endif
-		{
-	      res=InternetOpenUrl(hInternet,tmpv1+1,NULL,0,
-					    INTERNET_FLAG_NO_CACHE_WRITE,0);
-#ifdef DEBUG
-	      fprintf(stderr,"(%s) content-length : %d,,res.nDataAlloc %d \n",
-		      tmpv1+1,res.nDataAlloc,res.nDataLen);
-#endif
-	      char* tmpContent=(char*)malloc((res.nDataLen+1)*sizeof(char));
-	      size_t dwRead;
-	      InternetReadFile(res, (LPVOID)tmpContent,res.nDataLen, &dwRead);
-	      map* tmpMap=getMap(tmpmaps->content,"value");
-	      if(tmpMap!=NULL)
-		tmpMap->value=tmpContent;
-	    }
+	    if(CHECK_INET_HANDLE(hInternet))
+#endif
+	      {
+		res=InternetOpenUrl(hInternet,tmpv1+1,NULL,0,
+				    INTERNET_FLAG_NO_CACHE_WRITE,0);
+#ifdef DEBUG
+		fprintf(stderr,"(%s) content-length : %d,,res.nDataAlloc %d \n",
+			tmpv1+1,res.nDataAlloc,res.nDataLen);
+#endif
+		char* tmpContent=(char*)calloc((res.nDataLen+1),sizeof(char));
+		if(tmpContent == NULL){
+		  return errorException(m, "Unable to allocate memory.", "InternalError");
+		}
+		size_t dwRead;
+		InternetReadFile(res, (LPVOID)tmpContent,res.nDataLen, &dwRead);
+		map* tmpMap=getMap(tmpmaps->content,"value");
+		if(tmpMap!=NULL)
+		  tmpMap->value=strdup(tmpContent);
+		free(tmpContent);
+	      }
 	    addToMap(tmpmaps->content,tmpn1,tmpv1+1);
 	  }
 	  tmpc=strtok(NULL,"@");
 	}
+#ifdef DEBUG
+	dumpMaps(tmpmaps);
+	fflush(stderr);
+#endif
 	if(request_input_real_format==NULL)
-	  request_input_real_format=tmpmaps;
+	  request_input_real_format=dupMaps(&tmpmaps);
 	else
 	  addMapsToMaps(&request_input_real_format,tmpmaps);
-#ifdef DEBUG
-	dumpMaps(tmpmaps);
-	fflush(stderr);
-#endif
-	tmpmaps=tmpmaps->next;
+	/*freeMap(&tmpmaps->content);
+	free(tmpmaps->content);
+	tmpmaps->content=NULL;*/
+	freeMaps(&tmpmaps);
+	free(tmpmaps);
+	  //}
+	tmpmaps=NULL;
+	free(tmp);
       }
     }
-  } 
+    free(inputs_as_text);
+  }
   else {
+    /**
+     * Parse XML request
+     */ 
     xmlInitParser();
 #ifdef DEBUG
@@ -616,6 +738,6 @@
      */
     maps* tempMaps=NULL;
-    xmlNodeSet* tmps=extractFromDoc(doc,
-				    "/*/*/*[local-name()='Input']");
+    xmlXPathObjectPtr tmpsptr=extractFromDoc(doc,"/*/*/*[local-name()='Input']");
+    xmlNodeSet* tmps=tmpsptr->nodesetval;
 #ifdef DEBUG
     fprintf(stderr,"*****%d*****\n",tmps->nodeNr);
